/**
 ** Icons! Screensaver
 ** Copyright (c) 2002, Flaming Sword Productions
 ** Released into the Public Domain
 **
 ** Written by Brian C. Ledbetter <brian@shadowcom.net>
 ** http://www.shadowcom.net/Software/kss/icons/
 **
 ** $Id: Icon.h,v 1.1.1.1 2002/02/27 14:43:13 brian Exp $
 **/
#ifndef		__ICON_H__
#define		__ICON_H__
#include	<qtimer.h>
#include	<qvbox.h>
#include	<qpixmap.h>
#include	<qimage.h>
#include	<qbitmap.h>
#include	<ksharedpixmap.h>
#include	<kscreensaver.h>

/**
 ** class Icon: We will instantiate one of these for each visible icon we will
 ** expect to have.  A subset of [visible] - 2 will always be shown on the screen,
 ** with the 2 hidden icons being used to load new icon images from disc.  A seperate
 ** class should manage the display of these, but once show()n, the icon can handle its
 ** own display.
 **/
class		Icon: public QWidget {
Q_OBJECT
public:

		Icon( QWidget * );
		~Icon();

signals:
	void		refresh( Icon* );
	void		nextIcon();

public slots:
	void		show();
	void		hide();
	void		setIcon( const QString& = QString::null );

protected slots:
	void		movement();

	void		setSize( const QSize& );
	void		setPosition( const QPoint& );
	void		setVector( const QPoint& );
	void		loadIcon( const QString& = QString::null );

	void		determineGeometries();
	void		randomPosition();
	void		randomVector();

	void		initialize();

protected:
	void		clearEvent();
	void		paintEvent( QPaintEvent* );

	QTimer		_timer;
	QPoint		_position, _startingPosition, _maxPosition;
	QPoint		_vector;
	QSize		_size;

	int		_smallestSize, _largestSize, _visibleSize;
	QValueList<QPixmap> _icons;

	QWidget		*_paintDevice;

	bool		_visible;
};

#endif
