/**
 ** Icons! Screensaver
 ** Copyright (c) 2002, Flaming Sword Productions
 ** Released into the Public Domain
 **
 ** Written by Brian C. Ledbetter <brian@shadowcom.net>
 ** http://www.shadowcom.net/Software/kss/icons/
 **
 ** $Id: IconMgr.h,v 1.1.1.1 2002/02/27 14:43:13 brian Exp $
 **/
#ifndef		__ICONMGR_H__
#define		__ICONMGR_H__
#include	<qtimer.h>
#include	<qvbox.h>
#include	<qpixmap.h>
#include	<qimage.h>
#include	<qbitmap.h>
#include	"Icon.h"

/**
 ** class IconMgr: This object is designed to manage the display and
 ** loading of the individual Icon objects.  When an icon is finished
 ** with its display cycle, it tells this object to populate it with
 ** a new icon.
 **/
class		IconMgr: public QWidget {
Q_OBJECT
public:
		IconMgr( QWidget * );
		~IconMgr();

private slots:
	void		loadIcon( Icon * );
	void		showIcon();

protected:
	void		lastIconHidden();
	void		buildIconList();
	void		processIconDir( const QString& );
	QString		getNewIcon();

	QList<Icon>	_icons;

	QValueList<QString> _availableIconIndex;

	QWidget		*_paintDevice;

	QTimer		_timer;

	int		_currentIcon;

	bool		_showingIcon;
};

#endif
